//+------------------------------------------------------------------+
//|                                           MMP Multi-Hedge v1.mq4 |
//|                 Copyright  2007, Steve Wilson - SBW Enterprises |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Steve Wilson - SBW Enterprises"
#property link      "http://www.forex-tsd.com"

/*********************************************************************
Currently we are only displaying values on chart. We need to add the
open and close trade functions.

Please add comments to all changes and additions you make so we can 
all follow. Also increase version number to 1.2, 1.3 etc.
                      
                      To Do List
1. Calculate AutoRatio
2. Auto Open Trades when Volatility is below a given point ie -0.1
3. Close trades when account is in profit. Perhaps when volatility
   is above +0.1. Maybe use $ value and include swap.
4. Add Magic number to calculations.
5. Add MoneyManager function to calculate risk and pip size
6. Add Profit Target Function
7. Check calculations in function SymbolPrice() to ensure it is correct
8. Option to enter different symbols and EA will calculate correct ratios

*********************************************************************/


extern int        Magic       = 1000;   //Currently not used. Please add functionality.
extern bool       DisplayValues = true; // If false then values not shown on chart
extern bool       Autotrade   = true; 
extern string     Symbol1     = "EURUSD";
extern string     Symbol2     = "USDCHF";
extern string     Symbol3     = "EURCHF";
extern bool       Symbol1isLong = true;
extern bool       Symbol2isLong = true;
extern bool       Symbol3isLong = false;
extern double     LotsSize      = 0.01; 
extern bool       UseAutoRatio = false; // Need to calculate
extern double     ratio1   = 1;
extern double     ratio2   = 1;
extern double     ratio3   = 1;
extern bool       MoneyManager = true; // Not used yet. Needs to do.
extern int        ProfitTarget=0;    // Setting this value will calculate all open trades and close if profit reached.int profit        


double Symbol1Price=0, Symbol2Price=0, Symbol3Price=0;
double pp=0, pBid=0, volatility=0, v1=0;

bool init=true;

datetime timeprev=0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

SymbolPrice();
ChartComment();


   
//----
   return(0);
  }
//+------------------------------------------------------------------+


// Obtaining symbol PRICE for each of our 3 symbols and calculating volatility
void SymbolPrice()
{
   
      
      pp = MarketInfo(Symbol1, MODE_POINT); 
      //if(Symbol1isLong == true) pBid = MarketInfo(Symbol1, MODE_ASK);
      //   else pBid = MarketInfo(Symbol1, MODE_BID); // to determine if we should use ASK or BID price
      pBid = MarketInfo(Symbol1, MODE_ASK); 
      Symbol1Price = pBid;

      pp = MarketInfo(Symbol2, MODE_POINT); 
      //if(Symbol2isLong == true) pBid = MarketInfo(Symbol2, MODE_ASK); 
      //   else pBid = MarketInfo(Symbol2, MODE_BID);
      pBid = MarketInfo(Symbol2, MODE_ASK);
      Symbol2Price = pBid;   

      pp = MarketInfo(Symbol3, MODE_POINT); 
      //if(Symbol3isLong == true) pBid = MarketInfo(Symbol3, MODE_ASK); 
      //   else pBid = MarketInfo(Symbol3, MODE_BID);
      pBid = MarketInfo(Symbol3, MODE_ASK);
      Symbol3Price = pBid;
      
      // For perfect alignment (0.0000) Symbol1Price * Symbol3Price should = Symbol2Price. 
      //Ths may help to calculate auto ratios
      v1 = Symbol1Price * Symbol3Price;
      //volatility = ( v1 - Symbol2Price); // not sure how this should be calculated
      volatility = Symbol1Price * Symbol2Price * (1/Symbol3Price);
   
}


void ChartComment()
{

   if (DisplayValues == true){
      string sComment   = "";
      string sp         = "****************************\n";
      string NL         = "\n";

      sComment = NL + sp;
      sComment = sComment + Symbol1 + " Price = "+ DoubleToStr(Symbol1Price,4) + NL;
      sComment = sComment + Symbol2 + " Price = "+ DoubleToStr(Symbol2Price,4) + NL;
      sComment = sComment + Symbol3 + " Price = "+ DoubleToStr(Symbol3Price,4) + NL;
      sComment = sComment + Symbol1 + " X " + Symbol3 + " = "+ DoubleToStr(Symbol1Price * Symbol3Price,4) + NL + NL;
      sComment = sComment + "Volatility Price = "+ DoubleToStr(volatility,4) + NL;
      
      
      sComment = sComment + NL + sp;
      Comment(sComment);
   }
}	  




